<?php
/**
 * Plugin Name: Flex Optin Form - Aweber
 * Plugin URI: http://www.flexsqueeze.com
 * Description: Insert styled Aweber e-mail opt-in forms into FlexSqueeze theme
 * Version: 1.0
 * Author: Advantus Media, Inc.
 * Author URI: http://www.flexsqueeze.com
 */


add_action( 'widgets_init', 'flex_optin_aw' );

function flex_optin_aw() {
	register_widget( 'Flex_Widget_AW' );
}

/**
 * Flex Widget class.
 * This class handles everything that needs to be handled with the widget:
 * the settings, form, display, and update.  Nice!
 *
 * @since 0.1
 */
class Flex_Widget_AW extends WP_Widget {

	/**
	 * Widget setup.
	 */
	function Flex_Widget_AW() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'flexoptinaw', 'description' => __('Styled Aweber email opt-in forms for FlexSqueeze theme', 'flexoptinaw') );

		/* Widget control settings. */
		$control_ops = array( 'width' => 600, 'height' => 1000, 'id_base' => 'flex-widget' );

		/* Create the widget. */
		$this->WP_Widget( 'flex-widget', __('FlexSqueeze Aweber Opt-in', 'flexoptinaw'), $widget_ops, $control_ops );
	}

	/**
	 * How to display the widget on the screen.
	 */
	function widget( $args, $instance ) {
		extract( $args );

		/* Our variables from the widget settings. */
		$flexloc = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); 
		
		$title = apply_filters('widget_title', $instance['title']);
		$intro = $instance['intro'];
		$formid = $instance['formid'];
		$awhiddenfields = apply_filters( 'flexoptinaw', $instance['awhiddenfields'] );
		$customimage = apply_filters( 'flexoptinaw', $instance['customimage'] );
		$toppadding = $instance['toppadding'];
		$nametext = $instance['nametext'];
		$emailtext = $instance['emailtext'];
		$fbtn = $instance['fbtn'];
		$optinprivacy = $instance['optinprivacy'];
		$show_name = isset( $instance['show_name'] ) ? $instance['show_name'] : true;
		$btn_flash = isset( $instance['btn_flash'] ) ? $instance['btn_flash'] : true;
		
		$btnbgclr = $instance['btnbgclr'];
		
		$namejs = 'onfocus="if (this.value == \'' . $nametext . '\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \'' . $nametext . '\';}"';
		$emailjs = 'onfocus="if (this.value == \'' . $emailtext . '\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \'' . $emailtext . '\';}"';
		
		 
                


		/* Before widget (defined by themes). */
		
		if ($toppadding) { $paddingcode = 'padding-top:'. $toppadding .'px;'; }
		if ( $btnbgclr) { $bgcode = 'background-color: #'. $btnbgclr . ';'; } else { $bgcode = ""; }
		
		if ( $customimage != "" ) { echo '<div class="widget" style="'. $paddingcode .' background-image: url(' . $customimage . ');background-repeat:no-repeat;background-position:center top;"><ul>';}

		else {
		
		echo $before_widget;
                 if ( $title )
                        echo $before_title . $title . $after_title;
			;}
		echo '<form id="flex_optin-' . $formid . '" class="flexform" method="post" action="http://www.aweber.com/scripts/addlead.pl" style="width:100%;text-align:center;margin-top:10px;">';
		if ( $awhiddenfields != "Enter your hidden field values here" )
		echo $awhiddenfields;
		echo '<table width="100%"><tr><td><center>';
		echo $intro . '</center>';
		echo '</td></tr>';
		if ( $show_name == 0) { echo '<tr><td align="center"><input id="namefield" type="text" name="name" value="' . $nametext . '" ' . $namejs .' style="text-align:center;color:#333;"/></td></tr>'; }
		echo '<tr><td align="center"><input id="emailfield" type="text" name="email"  value="' . $emailtext .'" ' . $emailjs .' style="text-align:center;color:#333;"/></td></tr><tr><td align="center">		
		<div class="'; 
		if ( $btn_flash == 0) { echo 'flashing '; } echo 'submitbutton" style="height: 63px; width: 254px; ' . $bgcode . ' background-position:0 -63px; background-image: url(' . $flexloc . 'images/sub-' . $fbtn . '.png);">
		<a href="javascript:void(0);" onclick="submitForm(\'flex_optin-' . $formid . '\');" style="' . $bgcode . ' background-image: url(' . $flexloc . 'images/sub-' . $fbtn . '.png);" onmouseover="this.style.backgroundPosition=\'0  -63px\';" onmouseout="this.style.backgroundPosition=\'0 0\';"></a>
		</div>
<input type="submit" style="display:none;" />


</td></tr><tr><td><center><div style="margin-bottom:10px;padding:0 10px;">' . $optinprivacy . '</div></center></td></tr></table></form>';

		/* After widget (defined by themes). */

        echo $after_widget;
	}

	/**
	 * Update the widget settings.
	 */
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		/* Strip tags for title and name to remove HTML (important for text inputs). */
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['intro'] = $new_instance['intro'];
		$instance['optinprivacy'] = $new_instance['optinprivacy'];

		if ( current_user_can('unfiltered_html') )
                  $instance['awhiddenfields'] =  $new_instance['awhiddenfields'];
        else
                 $instance['awhiddenfields'] = stripslashes( wp_filter_post_kses( $new_instance['awhiddenfields'] ) );
           $instance['filter'] = isset($new_instance['filter']);
		   
		if ( current_user_can('unfiltered_html') )
                  $instance['customimage'] =  $new_instance['customimage'];
        else
                 $instance['customimage'] = stripslashes( wp_filter_post_kses( $new_instance['customimage'] ) );
        $instance['filter'] = isset($new_instance['filter']);
		$instance['nametext'] = $new_instance['nametext'];
		$instance['emailtext'] = $new_instance['emailtext'];
		$instance['fbtn'] = $new_instance['fbtn'];
		$instance['toppadding'] = $new_instance['toppadding'];
		$instance['show_name'] = $new_instance['show_name'];
		$instance['btn_flash'] = $new_instance['btn_flash'];
		$instance['formid'] = $new_instance['formid'];
		$instance['btnbgclr'] = $new_instance['btnbgclr'];

		return $instance;
	}

	/**
	 * Displays the widget settings controls on the widget panel.
	 * Make use of the get_field_id() and get_field_name() function
	 * when creating your form elements. This handles the confusing stuff.
	 */
	function form( $instance ) {

		/* Set up some default widget settings. */
		$defaults = array( 'intro' => __('<h2>Subscribe Today!</h2><p>Sign up today and get my FREE e-book!</p>', 'flexoptinaw'),  'optinprivacy' => __('I respect your privacy and will not share your email, period.', 'flexoptinaw'), 'awhiddenfields' => __('Enter your hidden field values here', 'flexoptinaw'),  'fbtn' => __('download-blue', 'flexoptinaw'), 'nametext' => __('Your Name', 'flexoptinaw'), 'emailtext' => __('Your Email', 'flexoptinaw'), 'show_name' => true, 'btn_flash' => true,  'formid' => __('1'));
		$instance = wp_parse_args( (array) $instance, $defaults ); 
		$awhf = format_to_edit($instance['awhiddenfields']);
		$title = esc_attr($instance['title']);

		?>
<table class="flex-optin">
<tr>
<td width="280"  valign="top" style="border-right:solid 1px #f2f2f2; padding-right:20px;">
		<p><strong>Note: You need a minimum width of 275px wherever you are using this widget!</strong></p>
		
		<!-- AW Hidden Fields: Text Input -->
        
        <p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>">Title: </label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $title; ?>" style="width:260px;" />
		</p>
        
        <p>
			<label for="<?php echo $this->get_field_id( 'formid' ); ?>">Form ID: </label>
			<input id="<?php echo $this->get_field_id( 'formid' ); ?>" name="<?php echo $this->get_field_name( 'formid' ); ?>" type="text" value="<?php echo $instance['formid']; ?>" style="width:20px;" /><br/>
            <p>If you have multiple forms on your site, give each one a unique ID number</p>
		</p>

			<label for="<?php echo $this->get_field_id( 'awhiddenfields' ); ?>"><?php _e('Aweber hidden form fields code:', 'flexoptinaw'); ?></label>
			<textarea class="widefat" style="width:260px;" rows="15" id="<?php echo $this->get_field_id( 'awhiddenfields' ); ?>" name="<?php echo $this->get_field_name( 'awhiddenfields' ); ?>"><?php echo $awhf; ?></textarea>
			<div style="height:1px;background-color:#f2f2f2;margin:10px auto;width:100%;"></div>
            
            
		<!-- Custom Image: Text Input -->
        <p>
			<label for="<?php echo $this->get_field_id( 'customimage' ); ?>"><?php _e('Custom background image (upload to the Media Library and paste the full URL below):', 'flexoptinaw'); ?></label>
			<input id="<?php echo $this->get_field_id( 'customimage' ); ?>" name="<?php echo $this->get_field_name( 'customimage' ); ?>"  type="text" value="<?php echo $instance['customimage']; ?>" style="width:260px;" />
		</p>
        <div style="height:1px;background-color:#f2f2f2;margin:10px auto;width:100%;"></div>
        
        
        <!-- Top Padding for Image -->
        <p>
			<label for="<?php echo $this->get_field_id( 'toppadding' ); ?>"><?php _e('Top padding to push text below your custom background image:', 'flexoptinaw'); ?></label>
			<input id="<?php echo $this->get_field_id( 'toppadding' ); ?>" name="<?php echo $this->get_field_name( 'toppadding' ); ?>"  type="text" value="<?php echo $instance['toppadding']; ?>" style="width:30px;" />
		</p>
        <div style="height:1px;background-color:#f2f2f2;margin:10px auto;width:100%;"></div>
        
        
        <!-- Optin Text: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'intro' ); ?>"><?php _e('Optional intro text:', 'flexoptinaw'); ?></label>
            <textarea name="<?php echo $this->get_field_name( 'intro' ); ?>" rows="4" id="<?php echo $this->get_field_id( 'intro' ); ?>"  type="text" style="width:260px;"><?php echo $instance['intro']; ?></textarea>
		</p>
        <div style="height:1px;background-color:#f2f2f2;margin:10px auto;width:100%;"></div>

</td>
<td width="280"  valign="top" style="padding-left:20px;">
   <!-- Custom field text: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'nametext' ); ?>"><?php _e('Name Field Text:', 'flexoptinaw'); ?></label>
			<input id="<?php echo $this->get_field_id( 'nametext' ); ?>" name="<?php echo $this->get_field_name( 'nametext' ); ?> type="text"" value="<?php echo $instance['nametext']; ?>" style="width:260px;" /><br/><br/>
            <label for="<?php echo $this->get_field_id( 'emailtext' ); ?>"><?php _e('Email Field Text:', 'flexoptinaw'); ?></label>
			<input id="<?php echo $this->get_field_id( 'emailtext' ); ?>" name="<?php echo $this->get_field_name( 'emailtext' ); ?>" type="text" value="<?php echo $instance['emailtext']; ?>" style="width:260px;" />
		</p>
        <div style="height:1px;background-color:#f2f2f2;margin:10px auto;width:100%;"></div>

		<!-- Show Name? Checkbox -->
		<p>
			<input class="checkbox" type="checkbox" <?php if( $instance['show_name'] == true ) { echo 'checked=checked'; }; ?> id="<?php echo $this->get_field_id( 'show_name' ); ?>" name="<?php echo $this->get_field_name( 'show_name' ); ?>" /> 
			<label for="<?php echo $this->get_field_id( 'show_name' ); ?>"><?php _e('Display Name Field?', 'flexoptinaw'); ?></label>
		</p>
        <div style="height:1px;background-color:#f2f2f2;margin:10px auto;width:100%;"></div>
        
        
        <!-- Privacy Tagline: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'optinprivacy' ); ?>"><?php _e('Privacy Statement:', 'flexoptinaw'); ?></label>
            <textarea name="<?php echo $this->get_field_name( 'optinprivacy' ); ?>" rows="2" id="<?php echo $this->get_field_id( 'optinprivacy' ); ?>" style="width:260px;"><?php echo $instance['optinprivacy']; ?></textarea>
		</p>
        <div style="height:1px;background-color:#f2f2f2;margin:10px auto;width:100%;"></div>
          
          <p>
			<input class="checkbox" type="checkbox" <?php if( $instance['btn_flash'] == true ) { echo 'checked=checked'; }; ?> id="<?php echo $this->get_field_id( 'btn_flash' ); ?>" name="<?php echo $this->get_field_name( 'btn_flash' ); ?>" /> 
			<label for="<?php echo $this->get_field_id( 'btn_flash' ); ?>"><?php _e('Use flashing button effect?', 'flexoptinaw'); ?></label>
		</p>
        <p>
			<label for="<?php echo $this->get_field_id( 'btnbgclr' ); ?>"><?php _e('If using flashing buttons, enter the background color of the surrounding box for smoother transitions in IE:', 'flexoptinaw'); ?></label><br/>
            #<input  id="<?php echo $this->get_field_id( 'btnbgclr' ); ?>" name="<?php echo $this->get_field_name( 'btnbgclr' ); ?>" type="text" value="<?php echo $instance['btnbgclr']; ?>" style="width:100px;" />
		</p>
         
		 <!-- Button Number: Text Box -->
        <div style="clear:left;"></div><p>Choose your button type from the list of buttons below.<br/>
        <label for="<?php echo $this->get_field_id( 'fbtn' ); ?>"><?php _e('Submit Button:', 'flexoptinaw'); ?></label>
			<input id="<?php echo $this->get_field_id( 'fbtn' ); ?>" class="<?php echo $this->get_field_id( 'fbtn' ); ?>" name="<?php echo $this->get_field_name( 'fbtn' ); ?>" type="text" value="<?php echo $instance['fbtn']; ?>" style="width:150px;" /><br/>
		</p>
        <p>These images show both the active and hover images used for each button.</p>
        
        <?php 
		$plugin_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'images/'; 
		$plugin_dir = WP_PLUGIN_DIR.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'images/'; 


//get all image files with a .png extension.
$images = glob($plugin_dir . "sub-*.png");
 
?>
<script type="text/javascript">
jQuery(document).ready(function() {
		jQuery('.<?php echo $this->get_field_id( 'fbtn' ); ?>').click(
  			 function() {
  			 jQuery('input[class=<?php echo $this->get_field_id( 'fbtn' ); ?>]').val(jQuery(this).attr('id'));
		});
	});
</script>
<?php
 
//print each file name
foreach($images as $image)
{
	$imageshort = str_replace($plugin_dir,"",$image);
	$imagenumber = str_replace("sub-","",$imageshort);
	$imageid = str_replace(".png","",$imagenumber);
	$imagetype = str_replace(".png","",$imagenumber);

echo '<img class="'; echo $this->get_field_id( 'fbtn' ); echo '" id="'.$imageid.'" src="'.$plugin_url . $imageshort .'" />';
}
 

?>

</td>
</tr>
</table>
	<?php
	}
}
if (is_admin()) {
function load_into_head() { ?>
<style type="text/css">
.flex-optin img {width:86px;float:left;margin-bottom:5px;;border:solid 2px #ffffff;}
.flex-optin img:hover {cursor:pointer;border:solid 2px #a10000;}
</style>
 <?php } add_action( is_admin() ? 'admin_head' : 'wp_head', 'load_into_head' );
}

?>